using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Drawing;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Runtime.Serialization;

using Syncfusion.Windows.Forms.Diagram;
/// <summary>
/// Summary description for CustomSymbol
/// </summary>
[Serializable]
public class CustomSymbol:Symbol
{
    private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
    private Ellipse innerEllipse = null;
	public CustomSymbol()
    {
        // Add an outer rectangle
        this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 100, 60);
        this.outerRect.Name = "Rectangle";
        this.outerRect.FillStyle.Color = Color.Khaki;
        this.AppendChild(outerRect);

        // Add an inner ellipse
        this.innerEllipse = new Ellipse(5, 5, 90, 50);
        this.innerEllipse.Name = "Ellipse";
        this.innerEllipse.FillStyle.Color = Color.LightBlue;
        this.AppendChild(innerEllipse);

        Syncfusion.Windows.Forms.Diagram.Label lbl = this.AddLabel("Syncfusion", BoxPosition.Center);
        lbl.BackgroundStyle.Color = Color.Transparent;
	}
    /// <summary>
        /// Serialization constructor for symbols.
        /// </summary>
        /// <param name="info">Serialization state information</param>
        /// <param name="context">Streaming context information</param>
        protected CustomSymbol(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        /// <summary>
        /// Populates a SerializationInfo with the data needed to
        /// serialize the target object.
        /// </summary>
        /// <param name="info">SerializationInfo object to populate</param>
        /// <param name="context">Destination streaming context</param>
        protected override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }

        /// <summary>
        /// Called when deserialization is complete.
        /// </summary>
        /// <param name="sender">Object performing the deserialization</param>
        protected override void OnDeserialization(object sender)
        {
            base.OnDeserialization(sender);

            // Get references to the child objects
            this.outerRect = this.GetChildByName("Rectangle") as Syncfusion.Windows.Forms.Diagram.Rectangle;
            this.innerEllipse = this.GetChildByName("Ellipse") as Ellipse;
        }
    }

