using System;
using System.Drawing;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Syncfusion.Web.UI.WebControls.Diagram;
using Syncfusion.Windows.Forms.Diagram;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Soap;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.IsPostBack == false)
        {
            this.Nodes();
            this.DiagramWebControl1.EnableNodeSelection = true;
            this.DiagramWebControl1.EnableDragDrop = true;
        }
        this.DiagramWebControl1.RenderImageMap = true;

    }

    private void Nodes()
    {
        string palettepath = Server.MapPath(string.Empty);
        palettepath = palettepath + @"\App_Data\Text Symbols.edp";
        SymbolPalette palette = this.LoadPalette(palettepath);

        InsertNodesCmd insCmd = new InsertNodesCmd();
        SymbolModel symModel = this.GetSymbolModel(palette, "Text in Rectangle");
        Symbol sym = symModel.CreateSymbol();
        insCmd.AddNode(sym, new PointF(10, 78));
        insCmd.Do(this.DiagramWebControl1.Model);
        insCmd.Nodes.Clear();
    }


    protected void Button1_Click(object sender, EventArgs e)
    {
        string palettepath = Server.MapPath(string.Empty);
        palettepath = palettepath + @"\App_Data\Text Symbols.edp";
        SymbolPalette palette = this.LoadPalette(palettepath);
        InsertNodesCmd insCmd = new InsertNodesCmd();
        SymbolModel symModel = this.GetSymbolModel(palette, "Text in Rectangle");
        if (symModel != null)
        {
            Symbol sym = symModel.CreateSymbol();
            insCmd.AddNode(sym, new PointF(20, 500));
            insCmd.Do(this.DiagramWebControl1.Model);
        }
    }

    public SymbolPalette LoadPalette(string filename)
    {
        SymbolPalette palette = null;
        if (File.Exists(filename))
        {
            FileStream iStream = new FileStream(filename, FileMode.Open, FileAccess.Read);
            SoapFormatter formatter = new SoapFormatter();
            formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
            formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
            System.AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(Syncfusion.DiagramBaseAssembly.AssemblyResolver);
            try
            {
                palette = (SymbolPalette)formatter.Deserialize(iStream);
            }
            catch (Exception e)
            {
                palette = null;
                System.Diagnostics.Trace.WriteLine("Error reading SymbolPalette", e.Message);
            }
            finally
            {
                iStream.Close();
                System.AppDomain.CurrentDomain.AssemblyResolve -= new ResolveEventHandler(Syncfusion.DiagramBaseAssembly.AssemblyResolver);
            }
        }
        return palette;
    }

    // Get the SymbolModel from the SymbolPalette
    public SymbolModel GetSymbolModel(SymbolPalette palette, string symbolName)
    {
        INode symmodel = palette.GetChildByName(symbolName);
        if (symmodel != null)
            return (SymbolModel)symmodel;
        return null;
    }
}
